﻿unit Unit26;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ComCtrls,
  Vcl.ExtCtrls, Data.DB, Data.Win.ADODB, ShellApi;

type
  TfReport = class(TForm)
    GroupBox1: TGroupBox;
    Panel1: TPanel;
    Button1: TButton;
    dtpFrom: TDateTimePicker;
    Label1: TLabel;
    dtpTo: TDateTimePicker;
    Label2: TLabel;
    qKassa: TADOQuery;
    qKassaid: TIntegerField;
    qKassadate_end: TDateTimeField;
    qKassabrand: TWideStringField;
    qKassamodel: TWideStringField;
    qKassaw_total: TFloatField;
    qKassasm_buyTotal: TFloatField;
    qKassasm_total: TFloatField;
    RadioGroup1: TRadioGroup;
    qFix: TADOQuery;
    qFixid: TIntegerField;
    qFixdate_end: TDateTimeField;
    qFixbrand: TWideStringField;
    qFixmodel: TWideStringField;
    qFixw_total: TFloatField;
    qFixsm_buyTotal: TFloatField;
    qFixsm_total: TFloatField;
    procedure Button1Click(Sender: TObject);
    procedure frxKassaReportGetValue(const VarName: string; var Value: Variant);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fReport: TfReport;

implementation

{$R *.dfm}

uses Unit2;

procedure TfReport.Button1Click(Sender: TObject);
   var
      TS, Style: TStringList;
      strFile, rows: string;
      buy_total, m_total, w_total, sm_total : Double;
begin
   if RadioGroup1.ItemIndex = 0 then begin
      TS := TStringList.Create;
      TS.LoadFromFile('Report\fixReport.html');
      Style := TStringList.Create;
      Style.LoadFromFile('Report\style.css');
      TS.Text := StringReplace(TS.Text, '{style}', Style.Text, [rfReplaceAll]);
      Style.Free;

      if qFix.Active then
         qFix.Close;
      qFix.Parameters[0].Value := FormatDateTime('yyyy-mm-dd', dtpFrom.Date)+' 00:00:00';
      qFix.Parameters[1].Value := FormatDateTime('yyyy-mm-dd', dtpTo.Date)+' 23:59:59';
      qFix.Open;
      buy_total := 0;
      m_total   := 0;
      w_total   := 0;
      sm_total  := 0;
      while not qFix.Eof do begin
         // Собираем строки для таблицы
         rows := rows + '<tr>'+
                '<td>'+qFixid.AsString+'</td>'+
                '<td class="text-right">'+qFixdate_end.AsString+'</td>'+
                '<td class="text-left">' +qFixbrand.AsString+' '+qFixmodel.AsString+'</td>'+
                '<td class="text-right">'+qFixsm_buyTotal.AsString+' ₽</td>'+
                '<td class="text-right">'+qFixsm_total.AsString+' ₽</td>'+
                '<td class="text-right">'+qFixw_total.AsString+' ₽</td>'+
                '<td class="text-right">'+FloatToStr(qFixw_total.AsFloat + qFixsm_total.AsFloat - qFixsm_buyTotal.AsFloat)+' ₽</td>'+
                '</tr>';
         // Собираем итоги в переменные
         buy_total := buy_total + qFixsm_buyTotal.AsFloat;   // Цена закупки ТМЦ
         m_total   := m_total   + qFixsm_total.AsFloat;      // Наша цена ТМЦ (с накруткой сервиса)
         w_total   := w_total   + qFixw_total.AsFloat;       // Стоимость работ
         sm_total  := sm_total  + (qFixw_total.AsFloat + qFixsm_total.AsFloat - qFixsm_buyTotal.AsFloat);   // Наша цена + стоимость работ - цена закупки ТМЦ (затраты)
         qFix.Next;
      end;

      TS.Text := StringReplace(TS.Text, '{title}', 'Отчет по ремонтам за период с '+FormatDateTime('dd-mm-yyyy', dtpFrom.Date)+' по '+FormatDateTime('dd-mm-yyyy', dtpTo.Date), [rfReplaceAll]);
      TS.Text := StringReplace(TS.Text, '{buy_total}', FloatToStr(buy_total), [rfReplaceAll]);
      TS.Text := StringReplace(TS.Text, '{m_total}',   FloatToStr(m_total),   [rfReplaceAll]);
      TS.Text := StringReplace(TS.Text, '{w_total}',   FloatToStr(w_total),   [rfReplaceAll]);
      TS.Text := StringReplace(TS.Text, '{sm_total}',  FloatToStr(sm_total),  [rfReplaceAll]);
      TS.Text := StringReplace(TS.Text, '{kassa}',     FloatToStr(m_total + w_total),  [rfReplaceAll]);
      TS.Text := StringReplace(TS.Text, '{rows}',      rows,                  [rfReplaceAll]);
      strFile := GetEnvironmentVariable('temp')+'\fixReport-'+qFixid.AsString+FormatDateTime('-ddmmyy-hms', Now)+'.html';
      TS.SaveToFile(strFile);
      ShellExecute(Handle, 'open', PChar(strFile), nil, nil, SW_SHOWNORMAL);
   end;
   if RadioGroup1.ItemIndex = 1 then begin
      //if qKassa.Active then
      //   qKassa.Close;
      //qKassa.Parameters[0].Value := FormatDateTime('yyyy-mm-dd', dtpFrom.Date)+' 00:00:00';
      //qKassa.Parameters[1].Value := FormatDateTime('yyyy-mm-dd', dtpTo.Date)+' 23:59:59';
      //qKassa.Open;
      ShowMessage('Этот отчет еще в разработке');
   end;
   if RadioGroup1.ItemIndex = 2 then begin
      ShowMessage('Этот отчет еще в разработке');
   end;
end;

procedure TfReport.FormCreate(Sender: TObject);
begin
   dtpFrom.Date := now();
   dtpTo.Date := now();
end;

procedure TfReport.frxKassaReportGetValue(const VarName: string;
  var Value: Variant);
begin
  if CompareText(VarName, 'dateFrom') = 0 then
     Value := FormatDateTime('yyyy-mm-dd', dtpFrom.Date);
  if CompareText(VarName, 'dateTo') = 0 then
     Value := FormatDateTime('yyyy-mm-dd', dtpTo.Date);
end;

end.
